--heading But I Don't Want to Look at the Sourcecode!
--bgcolor blue

--author Tim Laurence
--date today
--center TimDaMan@gmail.com
--newpage
--heading Introduction
---
Trained as a programer
---
Work as a Systems Administrator
---
Not a great programmer
---
Integration Work
---
My time at IBM 
--newpage
--heading Outline
* The edges of software
* What we can find out before we run a program?
* What is happening with the files?
* What is happening on the network?
* Misc..
--newpage The Edges of Software
--heading The Edges of Software
--newpage
--heading The Edges of Software
You go to the Dr.
* Dr. will ask questions
* May poke at you
* You may make requests of the Dr.
---
--horline

Your personal space ends where your doctors starts and vice-versa
* The Dr. can inspect you but you cannot inspect the Dr.
* Dr. follows diagnostic protocols
---
* Dr. could look inside but often uses much simpler techniques
--newpage User space and Kernel Space
--heading User space and Kernel Space
* User space and Kernel space
* All hardware access is done in kernel space
* Almost all programs run in user space
* Privilege rings
* We can look inside programs
* System calls.....
--newpage System calls
--heading System calls
Q: What is a system call?
---
A: It is the way programs ask the kernel to do something
--##newpage
--##heading How do system calls work?
--##-
--##* Load data into registers
--##-
--##* Execute interrupt/sysenter/syscall
--##-
--##* Kernel wakes up and reads registers
--##---
--##* Kernel processes data in registers
--##---
--##* Kernel updates registers with results
--##---
--##* Kernel sleeps and executes next instruction
--##--newpage
--##myProgram
--##newpage
--##myProgram --saves request-->CPU registers
--##newpage
--##myProgram -->executes interrupt and goes to sleep ....
--##-
--##... and the kernel wakes up 
--##newpage
--##kernel <-- reads CPU registers
--##-
--##processes the request...
--##-
--##stores the results...
--##-
--##and updates the CPU registers to reflect those results
--##newpage
--##kernel --> goes to sleep and starts myProgram on the next instruction...
--##-
--##myProgram wakes up on the next intruction and checks registers to get results of it's request
--##--newpage What are you so obsessed with system calls Tim?
--##--heading What are you so obsessed with system calls Tim?
--newpage It is all about the kernel
--heading It is all about the kernel
---

* This is were we are going to get most of our information
---
* Well established/documented interfaces
---
* Many tools that can display that data in usable ways
--newpage What Can we Find Out Before We Run a Program?
--heading What Can We Find Out Before We Run a Program?
---

--boldon
--center The tools
--boldoff

--center ldd
--center strings
--center man
--newpage ldd
ldd
* ldd gives you a list of libraries a program will load upon execution
* That's all!
* So why do we care?
---
--horline

* Libraries may be missing or incompatible
* Libraries can be broken too
* Helps figure what need if you going to move a program
---
--horline

Demo Time
---
--exec ./lddDemo
--newpage strings
--boldon 
--center strings
--boldoff

* Real simple, what human readable text is in a file?
* These can be the name of configuration files or message strings
---
--horline

Demo Time
---
--exec ./stringsDemo
--newpage man
--heading man
* Yes, that man!
* RTFM
* Often oddles of information at the bottom
---
--horline

--exec ./manDemo
--newpage One more hint
--heading One more hint

Don't forget /usr/share/doc/ProgramName
--newpage What is happening with the files?
--heading What is Happening With the Files?
---

--boldon
--center The Tools
--boldoff

--center lsof
--center inotify
--newpage lsof
--heading lsof
* LiSt of Open Files
* What files are opened by whom
* Almost everything is a file
* Limited in that only tells us what is open right now

---
--horline

lsof Demo
---

--exec ./lsofDemo
--newpage inotify
--heading inotify
* In begining there was polling
* Then came inotify
* Two commands; inotifywait; inotifywatch
*  inotifywait watches for activity
*  inotifywatch collects statistical information
* Limited to tell us when something changes
---
--horline

--exec ./inotifyDemo
--newpage What is Happening On the Network?
--heading What is Happening On the Network?
---

--boldon
--center The Tools
--boldoff

--center netstat
--center tcpdump/wireshark
--newpage netstat
--heading netstat

* All sorts of information about the networking subsystem of Linux
* Only concerned with who is listening, talking, waiting
* Limited in that it only describes a point in time
---
--horline

netstat Demo
---
--exec ./netstatDemo
--newpage What is packet sniffer
--heading What is a packet sniffer?
--newpage tcpdump/wireshark
--heading tcpdump/wireshark
* tcpdump works on the command line
* wireshark is a xwindows program. It gives you much more detail more easily 
* wireshark is a superset of tcpdump. Knowing tcpdump will make it easier to use
* I usually use tcpdump
---
--horline

tcpdump Demo
---
--exec ./tcpdumpDemo

wireshark Demo

--newpage Other network tools
--heading Other Network Tools
* ssldump 
* openssl s_client -connect ip:port
--newpage Misc...
--heading Misc...
---

--boldon
--center The Tools
--boldoff

--center strace 
--center top
--center apparmor
--newpage strace
--heading strace
* The most revealing of this talk
* Every system call as it happens
* More often too much info than too little
---
--horline

strace Demo
---
--exec ./straceDemo

--newpage top
--heading top
* Can give you all sorts of performance info
* Most people don't know how to change it to suit their needs
* Reverse sort, sort by memory, PID, etc...
---
--horline

top Demo
--newpage apparmor
--heading apparmor
* AppArmor is a security tool
* It can used to create good audits of a program
* Dual use tool
---
--horline

apparmor Demo
---
--newpage /proc

proc Demo
---
--exec ./procDemo
--newpage Questions
--huge Questions?
--newpage Thank you for comming.
--header But I Don't Want to Look at the Sourcecode!
--beginslidetop
--huge Thank You For Coming
--endslidetop
--center Tim Laurence
--center TimDaMan@gmail.com
